#include "header.h"

const WCHAR deviceLinkBuffer[] = L"\\DosDevices\\myDevice"; // Symlink for the device
const WCHAR deviceNameBuffer[] = L"\\Device\\myDevice"; // Define the device
PDEVICE_OBJECT pDeviceObject; // Pointer to device object

/*
 *  DriverEntry - Entry Point
 */
NTSTATUS DriverEntry(IN PDRIVER_OBJECT TheDriverObject, IN PUNICODE_STRING TheRegistryPath)
{
  //* (long *) 0x7000dcab = 50; BSOD for fun and profit
  //DbgPrint("This is my first driver baby!!");
  NTSTATUS ntStatus = 0;
  UNICODE_STRING      deviceNameUnicodeString;
  UNICODE_STRING      deviceLinkUnicodeString;

  // We set up the name and symbolic link in Unicode
  RtlInitUnicodeString(&deviceNameUnicodeString,
                       deviceNameBuffer);
  RtlInitUnicodeString(&deviceLinkUnicodeString, 
                       deviceLinkBuffer);
  
  // Set up the device myDevice
  ntStatus = IoCreateDevice(TheDriverObject, 
                            0, // Driver extension
							&deviceNameUnicodeString,
							FILE_DEVICE_ROOTKIT,
							0,
							TRUE,
							&pDeviceObject);
  
  if (NT_SUCCESS(ntStatus))
    ntStatus = IoCreateSymbolicLink(&deviceLinkUnicodeString,
                                   	&deviceNameUnicodeString);
  
  // Unload function and some Major Functions
  TheDriverObject->DriverUnload = CleanUp;
  TheDriverObject->MajorFunction[IRP_MJ_CREATE] = OpenFunction;
  TheDriverObject->MajorFunction[IRP_MJ_CLOSE] = CloseFunction;
  TheDriverObject->MajorFunction[IRP_MJ_READ] = ReadFunction;
  TheDriverObject->MajorFunction[IRP_MJ_WRITE] = WriteFunction;
  TheDriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = IoControlFunction;
  return STATUS_SUCCESS;
}
/*
*  CleanUp - Unload function
*/
VOID CleanUp(IN PDRIVER_OBJECT TheDriverObject)
{
  //DbgPrint("CleanUp routine called");
  UNICODE_STRING      deviceNameUnicodeString;
  UNICODE_STRING      deviceLinkUnicodeString;
  
  RtlInitUnicodeString(&deviceNameUnicodeString,
                       deviceNameBuffer);
  RtlInitUnicodeString(&deviceLinkUnicodeString, 
                       deviceLinkBuffer);
  
  IoDeleteSymbolicLink(&deviceNameUnicodeString);
  IoDeleteDevice(TheDriverObject->DeviceObject);
}